% NOTES:
% 
% Just run to see tracking.
%
% This script uses learned model to track the point in a testing sequence. Only linTrack function is used for tracking, the rest containts
% visualisation and I/O communication. The function linTrack could be easily re-implemented or changed.


close all
load leguan

% I/O options:
options.sequence = 'data/';%/datagrid/MultiCam/zimmerk/leguan/';
options.firstFrame = 1;
options.stepFrame = 3;
options.lastFrame = 270;
% tracking options:
options.firstIter = 1;                          % first used predictor in the sequence (first iteration)
options.iter = length(model.X);                 % number of iterations (default value correspond to the number of learned iterations)

d = dir(options.sequence);
I = find(~[d(:).isdir]); p =zeros(2,1); XX = [];

for i=I(options.firstFrame:options.stepFrame:options.lastFrame),
    im = [zeros(480,0) double(rgb2gray(imread([options.sequence, d(i).name])))/255];
    [p out]= linTrack(im, p, model, options); 
    if ~out, 
        p = zeros(2,1);
    end;
%% visualisation
    XX = [XX p(1:2)];
    clf; imshow(im); title(i); hold on;  
    plot(model.C(2)+XX(2,:),model.C(1)+XX(1,:),'-'); plot(model.C(2)+XX(2,:),model.C(1)+XX(1,:),'ro'); hold on
    %plot(model.C(2)+p(2),model.C(1)+p(1), 'k+','MarkerSize',25,'LineWidth',3); plot(model.C(2)+p(2),model.C(1)+p(1), 'ko','MarkerSize',19,'LineWidth',2);
    plot(model.C(2)+p(2),model.C(1)+p(1), 'rx','MarkerSize',10,'LineWidth',4); 
    drawnow;    
end;

