function model = tcLearn(im,trData)

%xp = [200;300];% [374;213]; %xp = [xp(2); xp(1)];  % [rows;cols]
imshow(rgb2gray(imread(trData.imgModel)));xp = round(ginput(1)); close; xp = [xp(2); xp(1)];
trData.xp = xp;
V = [] ;W = [];  model = []; iter = 1; cs = Inf; clear solution
time0 = clock; sol_complx=[];

while ((iter==1)||(length(V)>0))&&((etime(clock,time0)<trData.timeLimit)||(~exist('solution','var'))),   
%while ((iter==1)||(length(V)>0))&&(etime(clock,time0)<trData.timeLimit),   
    
%%  Take vertex (model) and remove from V
if length(V)>0,
    model = V(end).v; 
    L_old = V(end).L; t_old = V(end).t;
    V(end) = [];
end;

%% Read image
tic
%L=[]; t = []; open = 1; T = []; 

%% Estimate common support set
if iter==1,
[L,t, x0] = genExamples3(im, trData.ssRadius, xp, trData, [], model);
if strcmp(trData.ss,'lsq'),
    N = 500; rnd = genRnd(N,size(L,2)); 
    [JJ E0] = selectSupportSet(L(:,rnd ),t(:,rnd), max(trData.C)); L = L(JJ,:);
elseif strcmp(trData.ss,'rnd'),
    JJ = genRnd(max(trData.C),size(L,1));
end;
end;
L=[]; t = []; open = 1; T = []; 
%% Generate Examples
        
    if iter==1,
        [L0,t0, x0] = genExamples6(im, xp, trData, JJ, model);
    else
        [L0,t0, x0] = genExamples4(im, trData.ssRadius, xp, trData, L_old, t_old, JJ, model);
    end;
    if size(t0,2)>0, 
        L = [L L0] ; t = [t t0(trData.predTrans,:)]; T = [T t0]; 
    end;   


time_genexamples = toc;
tic
%% Learn Model
for k=1:length(trData.C),
m = learnMultiLSQ(L, t, trData.C(k), JJ, trData);
%m.Err = model(k).H*L(model(k).I,:) - t;
%%[a b] = hist(m.Err',30); plot(b,a/(b(2)-b(1))); grid on; drawnow; hold on;
m.covErr =  mean(sqrt(sum(m.Err.^2))');
%trace(cov(m.Err'));

%% Updating vertices in graph
if m.covErr<trData.maxCovErr,
    if (~exist('solution','var'))||(complx([model m]) < complx(solution)),
        if exist('solution','var'), 
            W(length(W)+1).v = solution; 
        else
            [a b] = sort(abs(median(trData.C)-trData.C),'descend'); trData.C = trData.C(b);
        end;
        solution = [model m]; cs = complx(solution); sol_complx = [sol_complx [iter;cs]];
        disp(sprintf('Found solution with complexity:%d',cs));
    else
        
        W(length(W)+1).v = [model m];     % if [model m] is not better then solution then add to closed and kill
        disp(sprintf('Found and killed solution with complexity:%d',complx([model m])));
    end;    
else
    if ((length(model)+1)<=trData.maxDepth)&&(complx([model m])<cs),
        V(length(V)+1).v = [model m];    
        V(end).L = L(1:m.C,:);%L(JJ(1:m.C),:);
        V(end).t = T;
    else
        W(length(W)+1).v = [model m];     % if [model m] is worse then solution or maxDepth is reached then add to closed and kill
    end;
end;
  J = false(1,length(V));     % kill all more complex vertices
        for j=1:length(V),
            J(j) = complx(V(j).v)>=cs;
            if J(j), closed.v = V(j).v; W = [W closed]; end;
        end;
        if length(V(J))>0,             
            V(J) = [];        
        end;

end;
disp(sprintf('The best so far found solution:C=%d, |V|=%d, |W|=%d',cs, length(V), length(W)));
time_learning = toc
if trData.visu,
clf; for j=1:length(V), plot(0:length(V(j).v),[trData.tMax V(j).v(:).covErr],'.-','LineWidth',2); hold on; end; 
for j=1:length(W), plot(0:length(W(j).v), [trData.tMax W(j).v(:).covErr],'k-.','LineWidth',2); hold on; end; 
if exist('solution','var'), for j=1:length(solution), plot(0:length(solution),[trData.tMax solution.covErr],'ro-','LineWidth',3); hold on; end; end;
xlabel('Graph depth','FontSize', 15); ylabel('Prediction error','FontSize', 15);
%mx = 5; plot([0 mx],[trData.maxCovErr trData.maxCovErr],'k--','LineWidth',2); xlim([0 mx]);set(gca,'XTick',[0:mx]); ylim([0 0.4]);
set(gca,'FontSize',16); set(gca,'XTick',[0:max(get(gca,'XTick'))]);
plot([0:max(get(gca,'XTick'))],[trData.maxCovErr*ones(1,max(get(gca,'XTick'))+1)],'k--');
grid on; drawnow;
if trData.sav,
    print('-dpng',['graph_bb',num2normstr(iter,4),'.png']);
    %print('-depsc',['graph_bb',num2normstr(iter,4),'.eps']);
end;
end;
iter = iter + 1;
%print('-dpng',['bb',num2normstr(iter,4),'.png']);
end;   % of while
%% Adding last minimax iteration with maximal complexity

if false,
[L0, t0, x0] = genExamples3(im, trData.ssRadius, xp, trData, JJ, model);
t0 = t0(trData.predTrans,:);
m.H = minmaxL0L0(L0,t0);
m.I = JJ;
m.Err = m.H*L0-t0;
m.R = max(abs(t0)');
m.C = max(trData.C);
solution = [solution m];
end;


model = transformModel(solution, trData);
model.trData.learningTime = etime(clock,time0);

figure; plot(sol_complx(1,:), sol_complx(2,:),'LineWidth',2); xlabel('iter','FontSize',15); ylabel('complexity of solution','FontSize',15); grid on;